package PipSqueek::Plugin::Chanserv;
use base qw(PipSqueek::Plugin);
use strict;
sub plugin_initialize
{
	my $self = shift;
	$self->plugin_handlers([
		'private_csadd',
		'private_csident',
		'private_csdel',
		'private_csget',
		'private_csmod',
		'private_csdbident',
	]);

	my $schema = [
		[ 'id',			'INTEGER PRIMARY KEY' ],
		[ 'channel',	'VARCHAR NOT NULL' ],
		[ 'password',	'VARCHAR NOT NULL' ],
		[ 'userpass',	'VARCHAR NOT NULL' ],
	];
	$self->dbi()->install_schema( 'chanserv', $schema );
}

sub private_csadd
{
 	my ($self,$message) = @_;
	my ($channel,$password,$userpass) = split(/\s+/,$message->command_input()); 
	if(defined($channel) && defined($password) && defined($userpass))
	{
		my $cserv = $self->dbi()->select_record('chanserv',{'channel' => $channel }) ;		
		if($cserv->{'id'} !=0 )
		{
			$self->respond($message,"Channel $cserv->{'channel'} already exists for Chanserv db");
		}
		else
		{
			my $cserv = $self->dbi()->create_record('chanserv', { 'channel' => $channel,'password' => $password,'userpass' => $userpass});
			$self->respond($message,"Added Channel $cserv->{'channel'} to Chanserv db");
		}
	}	
	else
	{
		$self->client()->privmsg($message->nick(),"Use !cshelp csdel");
	}
	return;
}
sub private_csdel
{
	my ($self,$message) = @_;
	my ($channel,$userpass) = split(/\s+/,$message->command_input()); 
	if(defined($channel) && defined($userpass))
	{
		my $cserv = $self->dbi()->select_record('chanserv',{'channel' => $channel});
		if ($cserv->{'id'}!=0 && $cserv->{'userpass'} eq $userpass)
		{
			$self->dbi()->delete_record('chanserv', $cserv);
			$self->respond($message,"Deleted channel $cserv->{'channel'} from Chanserv db");
		}
		else
		{
			$self->respond($message,"Channel $channel does not exist Chanserv db or Userpass incorrect");
		}
	}	
	else
	{
		$self->client()->privmsg($message->nick(),"Use !cshelp csdel");
	}
	return;
}
sub private_csget
{
	my ($self,$message) = @_;
	my ($channel,$userpass) = split(/\s+/,$message->command_input()); 
	if(defined($channel) && defined($userpass))
	{
		my $cserv = $self->dbi()->select_record('chanserv',{'channel' => $channel }) ;		
		if($cserv-{'id'}!=0 && $cserv->{'userpass'} eq $userpass)
		{
			$self->respond($message,"Channel = $cserv->{'channel'} And Password = $cserv->{'password'}");
		}
		else
		{
			$self->respond($message,"Channel $channel does not exist Chanserv db or Password Incorrect");
		}
	}		
	else
	{
		$self->client()->privmsg($message->nick(),"Use !cshelp csget");
	}
	return;
}
sub private_csmod
{
	my ($self,$message) = @_;
	my ($what,$channel,$userpass,$password) = split(/\s+/,$message->command_input()); 
	if(defined($what) && defined($channel) && defined ($password) && defined($userpass))
	{	
		if($what eq 'chanpass')
		{
			my $cserv = $self->dbi()->select_record('chanserv',{'channel' => $channel }) ;		
			if($cserv-{'id'}!=0 && $cserv->{'userpass'} eq $userpass)
			{
				$cserv->{'password'} = $password;
				$self->dbi()->update_record('chanserv', $cserv);
				$self->respond($message,"Channel Password for $cserv->{'channel'} password has been changed in Chanserv db");
			}
			else
			{
				$self->respond($message,"Channel $cserv->{'channel'} does not exist Chanserv db");
			}
		}	
		if($what eq 'userpass')
		{
			my $cserv = $self->dbi()->select_record('chanserv',{'channel' => $channel }) ;		
			if($cserv-{'id'}!=0 && $cserv->{'userpass'} eq $userpass)
			{
				$cserv->{'userpass'} = $password;
				$self->dbi()->update_record('chanserv', $cserv);
				$self->respond($message,"User Password for $cserv->{'channel'} password has been changed in Chanserv db");
			}
			else
			{
				$self->respond($message,"Channel $cserv->{'channel'} does not exist Chanserv db");
			}
		}	
	}		
	else
	{
		$self->client()->privmsg($message->nick(),"Use !cshelp csmod");
	}
	return;
}

sub private_csident
{
	my ($self,$message) = @_;
	my ($channel,$password) = split(/\s+/,$message->command_input()); 
	my $cserv;
	if(defined($channel) && defined($password))
	{	
		$self->client()->privmsg( 'chanserv', "identify $channel $password");
		$self->client()->part( $channel);
		$self->client()->join( $channel);
		return;
	}
	else
	{
		$self->client()->privmsg($message->nick(),"Use !chelp csident");
	}
}
sub private_csdbident
{
	my ($self,$message) = @_;
	my ($channel,$userpass) = split(/\s+/,$message->command_input()); 
	my ($cserv,$password);
	if(defined($channel) && defined($userpass))
	{	
		$cserv = $self->dbi()->select_record('chanserv', { 'channel' => $channel });
		if($cserv->{'userpass'} eq $userpass)
		{
			$channel = $cserv->{'channel'};
			$password = $cserv->{'password'};
			$self->client()->privmsg( 'chanserv', "identify $channel $password");
			$self->client()->part( $channel);
			$self->client()->join( $channel);
		}
		else
		{
			$self->client()->privmsg($message->nick(),"Password Incorrect");
		}
	}
	else
	{
			$self->client()->privmsg($message->nick(),"Use !cshelp csident");
	}
		return;
}

1;
__END__
